Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limistate.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limistate.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limistate.F90	(revision 3938)
@@ -5,5 +5,6 @@
    !!======================================================================
    !! History :  2.0  ! 2004-01 (C. Ethe, G. Madec)  Original code
-   !!            4.0  ! 2011-02  (G. Madec) dynamical allocation
+   !!            4.0  ! 2011-02 (G. Madec) dynamical allocation
+   !!             -   ! 2012    (C. Rousset) clean + add par_oce (for jp_sal)...bug?
    !!----------------------------------------------------------------------
 #if defined key_lim3
@@ -21,4 +22,5 @@
    USE ice              ! sea-ice variables
    USE par_ice          ! ice parameters
+   USE par_oce          ! ocean parameters
    USE dom_ice          ! sea-ice domain
    USE in_out_manager   ! I/O manager
@@ -63,13 +65,13 @@
       !!                or from arbitrary sea-ice conditions
       !!-------------------------------------------------------------------
-      INTEGER  ::   ji, jj, jk, jl             ! dummy loop indices
-      REAL(wp) ::   zeps6, zeps, ztmelts, epsi06   ! local scalars
-      REAL(wp) ::   zvol, zare, zh, zh1, zh2, zh3, zan, zbn, zas, zbs 
-      REAL(wp), POINTER, DIMENSION(:)   ::   zgfactorn, zhin 
-      REAL(wp), POINTER, DIMENSION(:)   ::   zgfactors, zhis
+      INTEGER  ::   ji, jj, jk, jl            ! dummy loop indices
+      INTEGER  ::   i_fill, jl0, ztest_1, ztest_2, ztest_3, ztest_4, ztests  
+      REAL(wp) ::   zarg, zV, zconv
+      REAL(wp) ::   zeps06, zeps, ztmelts   ! local scalars
+      REAL(wp),          DIMENSION(jpl) ::   zain, zhtin, zhtsn, zais, zhtis, zhtss 
+      REAL(wp),          DIMENSION(jpl) ::   zai, zhti, zhts 
       REAL(wp), POINTER, DIMENSION(:,:) ::   zidto      ! ice indicator
       !--------------------------------------------------------------------
 
-      CALL wrk_alloc( jpm, zgfactorn, zgfactors, zhin, zhis )
       CALL wrk_alloc( jpi, jpj, zidto )
 
@@ -77,5 +79,4 @@
       ! 1) Preliminary things 
       !--------------------------------------------------------------------
-      epsi06 = 1.e-6_wp
 
       CALL lim_istate_init     !  reading the initials parameters of the ice
@@ -106,88 +107,208 @@
 
       ! constants for heat contents
-      zeps   = 1.e-20_wp
-      zeps6  = 1.e-06_wp
-
-      ! zgfactor for initial ice distribution
-      zgfactorn(:) = 0._wp
-      zgfactors(:) = 0._wp
-
-      ! first ice type
-      DO jl = ice_cat_bounds(1,1), ice_cat_bounds(1,2)
-         zhin (1)     = ( hi_max(jl-1) + hi_max(jl) ) * 0.5_wp
-         zgfactorn(1) = zgfactorn(1) + exp(-(zhin(1)-hginn_u)*(zhin(1)-hginn_u) * 0.5_wp )
-         zhis (1)     = ( hi_max(jl-1) + hi_max(jl) ) * 0.5_wp
-         zgfactors(1) = zgfactors(1) + exp(-(zhis(1)-hgins_u)*(zhis(1)-hgins_u) * 0.5_wp )
-      END DO ! jl
-      zgfactorn(1) = aginn_u / zgfactorn(1)
-      zgfactors(1) = agins_u / zgfactors(1)
-
-      ! -------------
-      ! new distribution, polynom of second order, conserving area and volume
-      zh1 = 0._wp
-      zh2 = 0._wp
-      zh3 = 0._wp
+      zeps    = 1.e-20_wp
+      zeps06  = 1.e-06_wp
+
+      !-------------------------------------------------------------------
+      ! 3) Distribute ice concentration and thickness into the categories 
+      !-------------------------------------------------------------------
+      ! snow distribution
+      zhtsn(1:jpl) = 0.d0
+      zhtss(1:jpl) = 0.d0
       DO jl = 1, jpl
-         zh = ( hi_max(jl-1) + hi_max(jl) ) * 0.5_wp
-         zh1 = zh1 + zh
-         zh2 = zh2 + zh * zh
-         zh3 = zh3 + zh * zh * zh
+         zhtsn(jl) = hninn
+         zhtss(jl) = hnins
       END DO
-      IF(lwp) WRITE(numout,*) ' zh1 : ', zh1
-      IF(lwp) WRITE(numout,*) ' zh2 : ', zh2
-      IF(lwp) WRITE(numout,*) ' zh3 : ', zh3
-
-      zvol = aginn_u * hginn_u
-      zare = aginn_u
-      IF( jpl >= 2 ) THEN
-         zbn = ( zvol*zh2 - zare*zh3 ) / ( zh2*zh2 - zh1*zh3)
-         zan = ( zare - zbn*zh1 ) / zh2
+
+      ! -------------------
+      ! Northern Hemisphere
+      ! -------------------
+      ! initialisation of tests
+      ztest_1 = 0
+      ztest_2 = 0
+      ztest_3 = 0
+      ztest_4 = 0
+      ztests  = 0
+         
+      i_fill = jpl + 1                                    !====================================
+      DO WHILE ( ( ztests /= 4 ) .AND. ( i_fill >= 2 ) )  ! iterative loop on i_fill categories  
+         ! iteration                                      !====================================
+         i_fill = i_fill - 1
+ 
+         ! initialisation of ice variables for each try
+         zhtin(1:jpl) = 0.d0
+         zain (1:jpl) = 0.d0
+         
+         ! *** case very thin ice: fill only category 1
+         IF ( i_fill == 1 ) THEN
+            zhtin(1) = hginn_u
+            zain (1) = aginn_u
+            
+            ! *** case ice is thicker: fill categories >1
+         ELSE
+            
+            ! Fill ice thicknesses except the last one (i_fill) by (hmax-hmin)/2 
+            DO jl = 1, i_fill - 1
+               zhtin(jl) = ( hi_max(jl) + hi_max(jl-1) ) / 2.
+            END DO
+            
+            ! find which category (jl0) the input ice thickness falls into
+            jl0 = i_fill
+            DO jl = 1, i_fill
+               IF ( ( hginn_u >= hi_max(jl-1) ) .AND. ( hginn_u < hi_max(jl) ) ) THEN
+                  jl0 = jl
+                  CYCLE
+               ENDIF
+            END DO
+            
+            ! Concentrations in the (i_fill-1) categories 
+            zain(jl0) = aginn_u / SQRT(REAL(jpl))
+            DO jl = 1, i_fill - 1
+               IF ( jl == jl0 ) CYCLE
+               zarg           = ( zhtin(jl) - hginn_u ) / ( hginn_u / 2. )
+               zain(jl) =   zain (jl0) * EXP(-zarg**2)
+            END DO
+            
+            ! Concentration in the last (i_fill) category
+            zain(i_fill) = aginn_u - SUM( zain(1:i_fill-1) )
+            
+            ! Ice thickness in the last (i_fill) category
+            zV = SUM( zain(1:i_fill-1) * zhtin(1:i_fill-1) )
+            zhtin(i_fill) = ( hginn_u*aginn_u -  zV ) / zain(i_fill) 
+            
+         ENDIF ! case ice is thick or thin
+         
+         !---------------------
+         ! Compatibility tests
+         !--------------------- 
+         ! Test 1: area conservation
+         zconv = ABS( aginn_u - SUM( zain(1:jpl) ) )
+         IF ( zconv < zeps06 ) ztest_1 = 1
+         
+         ! Test 2: volume conservation
+         zconv = ABS( hginn_u*aginn_u - SUM( zain(1:jpl)*zhtin(1:jpl) ) )
+         IF ( zconv < zeps06 ) ztest_2 = 1
+         
+         ! Test 3: thickness of the last category is in-bounds ?
+         IF ( zhtin(i_fill) >= hi_max(i_fill-1) ) ztest_3 = 1
+         
+         ! Test 4: positivity of ice concentrations
+         ztest_4 = 1
+         DO jl = 1, i_fill
+            IF ( zain(jl) < 0.0d0 ) ztest_4 = 0
+         END DO
+         
+         ztests = ztest_1 + ztest_2 + ztest_3 + ztest_4
+                                                        !============================
+      END DO                                            ! end iteration on categories
+                                                        !============================
+      ! Check if tests have passed (i.e. volume conservation...)
+      IF ( ztests .NE. 4 ) THEN
+         WRITE(numout,*) ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! '
+         WRITE(numout,*) ' !! ALERT categories distribution !!'
+         WRITE(numout,*) ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! '
+         WRITE(numout,*) ' *** ztests is not equal to 4 '
+         WRITE(numout,*) ' *** ztest (1:4) = ', ztest_1, ztest_2, ztest_3, ztest_4
       ENDIF
 
-      IF(lwp) WRITE(numout,*) ' zvol: ', zvol
-      IF(lwp) WRITE(numout,*) ' zare: ', zare
-      IF(lwp) WRITE(numout,*) ' zbn : ', zbn 
-      IF(lwp) WRITE(numout,*) ' zan : ', zan 
-
-      zvol = agins_u * hgins_u
-      zare = agins_u
-      IF( jpl >= 2 ) THEN
-         zbs = ( zvol*zh2 - zare*zh3 ) / ( zh2*zh2 - zh1*zh3)
-         zas = ( zare - zbs*zh1 ) / zh2
+      ! -------------------
+      ! Southern Hemisphere
+      ! -------------------
+      ! initialisation of tests
+      ztest_1 = 0
+      ztest_2 = 0
+      ztest_3 = 0
+      ztest_4 = 0
+      ztests  = 0
+         
+      i_fill = jpl + 1                                    !====================================
+      DO WHILE ( ( ztests /= 4 ) .AND. ( i_fill >= 2 ) )  ! iterative loop on i_fill categories  
+         ! iteration                                      !====================================
+         i_fill = i_fill - 1
+ 
+         ! initialisation of ice variables for each try
+         zhtis(1:jpl) = 0.d0
+         zais (1:jpl) = 0.d0
+         
+         ! *** case very thin ice: fill only category 1
+         IF ( i_fill == 1 ) THEN
+            zhtis(1) = hgins_u
+            zais (1) = agins_u
+            
+            ! *** case ice is thicker: fill categories >1
+         ELSE
+            
+            ! Fill ice thicknesses except the last one (i_fill) by (hmax-hmin)/2 
+            DO jl = 1, i_fill - 1
+               zhtis(jl) = ( hi_max(jl) + hi_max(jl-1) ) / 2.
+            END DO
+            
+            ! find which category (jl0) the input ice thickness falls into
+            jl0 = i_fill
+            DO jl = 1, i_fill
+               IF ( ( hgins_u >= hi_max(jl-1) ) .AND. ( hgins_u < hi_max(jl) ) ) THEN
+                  jl0 = jl
+                  CYCLE
+               ENDIF
+            END DO
+            
+            ! Concentrations in the (i_fill-1) categories 
+            zais(jl0) = agins_u / SQRT(REAL(jpl))
+            DO jl = 1, i_fill - 1
+               IF ( jl == jl0 ) CYCLE
+               zarg           = ( zhtis(jl) - hgins_u ) / ( hgins_u / 2. )
+               zais(jl) =   zais (jl0) * EXP(-zarg**2)
+            END DO
+            
+            ! Concentration in the last (i_fill) category
+            zais(i_fill) = agins_u - SUM( zais(1:i_fill-1) )
+            
+            ! Ice thickness in the last (i_fill) category
+            zV = SUM( zais(1:i_fill-1) * zhtis(1:i_fill-1) )
+            zhtis(i_fill) = ( hgins_u*agins_u -  zV ) / zais(i_fill) 
+            
+         ENDIF ! case ice is thick or thin
+         
+         !---------------------
+         ! Compatibility tests
+         !--------------------- 
+         ! Test 1: area conservation
+         zconv = ABS( agins_u - SUM( zais(1:jpl) ) )
+         IF ( zconv < zeps06 ) ztest_1 = 1
+         
+         ! Test 2: volume conservation
+         zconv = ABS( hgins_u*agins_u - SUM( zais(1:jpl)*zhtis(1:jpl) ) )
+         IF ( zconv < zeps06 ) ztest_2 = 1
+         
+         ! Test 3: thickness of the last category is in-bounds ?
+         IF ( zhtis(i_fill) >= hi_max(i_fill-1) ) ztest_3 = 1
+         
+         ! Test 4: positivity of ice concentrations
+         ztest_4 = 1
+         DO jl = 1, i_fill
+            IF ( zais(jl) < 0.0d0 ) ztest_4 = 0
+         END DO
+         
+         ztests = ztest_1 + ztest_2 + ztest_3 + ztest_4
+                                                        !============================
+      END DO                                            ! end iteration on categories
+                                                        !============================
+      ! Check if tests have passed (i.e. volume conservation...)
+      IF ( ztests .NE. 4 ) THEN
+         WRITE(numout,*) ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! '
+         WRITE(numout,*) ' !! ALERT categories distribution !!'
+         WRITE(numout,*) ' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! '
+         WRITE(numout,*) ' *** ztests is not equal to 4 '
+         WRITE(numout,*) ' *** ztest (1:4) = ', ztest_1, ztest_2, ztest_3, ztest_4
       ENDIF
-
-      IF(lwp) WRITE(numout,*) ' zvol: ', zvol
-      IF(lwp) WRITE(numout,*) ' zare: ', zare
-      IF(lwp) WRITE(numout,*) ' zbn : ', zbn 
-      IF(lwp) WRITE(numout,*) ' zan : ', zan 
-
-      !end of new lines
-      ! -------------
-!!!
-      ! retour a LIMA_MEC
-      !     ! second ice type
-      !     zdummy  = hi_max(ice_cat_bounds(2,1)-1)
-      !     hi_max(ice_cat_bounds(2,1)-1) = 0.0
-
-      !     ! here to change !!!!
-      !     jm = 2
-      !     DO jl = ice_cat_bounds(jm,1), ice_cat_bounds(jm,2)
-      !        zhin (2)     = ( hi_max(jl-1) + hi_max(jl) ) / 2.0
-      !        zhin (2)     = ( hi_max_typ(jl-ice_cat_bounds(2,1),jm    ) + &
-      !                         hi_max_typ(jl-ice_cat_bounds(2,1) + 1,jm)   ) / 2.0
-      !        zgfactorn(2) = zgfactorn(2) + exp(-(zhin(2)-hginn_d)*(zhin(2)-hginn_d)/2.0)
-      !        zhis (2)     = ( hi_max(jl-1) + hi_max(jl) ) / 2.0
-      !        zhis (2)     = ( hi_max_typ(jl-ice_cat_bounds(2,1),jm    ) + &
-      !                         hi_max_typ(jl-ice_cat_bounds(2,1) + 1,jm)   ) / 2.0
-      !        zgfactors(2) = zgfactors(2) + exp(-(zhis(2)-hgins_d)*(zhis(2)-hgins_d)/2.0)
-      !     END DO ! jl
-      !     zgfactorn(2) = aginn_d / zgfactorn(2)
-      !     zgfactors(2) = agins_d / zgfactors(2)
-      !     hi_max(ice_cat_bounds(2,1)-1) = zdummy
-      ! END retour a LIMA_MEC
-!!!
-
-!!gm  optimisation :  loop over the ice categories inside the ji, jj loop !!!
-
+!!
+!!
+!!
+      ! ---------------------
+      ! 4) fill ice variables
+      ! ---------------------
+      zai(:) = 0.0
+      zhti(:)= 0.0
+      zhts(:)= 0.0
       DO jj = 1, jpj
          DO ji = 1, jpi
@@ -195,257 +316,97 @@
             !--- Northern hemisphere
             !----------------------------------------------------------------
-            IF( fcor(ji,jj) >= 0._wp ) THEN    
-
+            IF( fcor(ji,jj) >= 0._wp ) THEN
+               zai(:) = zain(:) ; zhti(:) = zhtin(:) ; zhts(:) = zhtsn(:)     
+            ELSE 
+               zai(:) = zais(:) ; zhti(:) = zhtis(:) ; zhts(:) = zhtss(:)     
+            ENDIF
+            
+            DO jl = 1, jpl
                !-----------------------
                ! Ice area / thickness
                !-----------------------
-
-               IF ( jpl .EQ. 1) THEN ! one category
-
-                  DO jl = ice_cat_bounds(1,1), ice_cat_bounds(1,2) ! loop over ice thickness categories
-                     a_i(ji,jj,jl)    = zidto(ji,jj) * aginn_u
-                     ht_i(ji,jj,jl)   = zidto(ji,jj) * hginn_u
-                     v_i(ji,jj,jl)    = ht_i(ji,jj,jl)*a_i(ji,jj,jl)
-                  END DO
-
-               ELSE ! several categories
-
-                  DO jl = ice_cat_bounds(1,1), ice_cat_bounds(1,2) ! loop over ice thickness categories
-                     zhin(1)          = ( hi_max(jl-1) + hi_max(jl) ) / 2.0
-                     a_i(ji,jj,jl)    = zidto(ji,jj) * MAX( zgfactorn(1) * exp(-(zhin(1)-hginn_u)* & 
-                        (zhin(1)-hginn_u)/2.0) , epsi06)
-                     ! new line
-                     a_i(ji,jj,jl)    = zidto(ji,jj) * ( zan * zhin(1) * zhin(1) + zbn * zhin(1) )
-                     ht_i(ji,jj,jl)   = zidto(ji,jj) * zhin(1) 
-                     v_i(ji,jj,jl)    = ht_i(ji,jj,jl)*a_i(ji,jj,jl)
-                  END DO
-
-               ENDIF
-
-
-!!!
-               ! retour a LIMA_MEC
-               !              !ridged ice
-               !              zdummy  = hi_max(ice_cat_bounds(2,1)-1)
-               !              hi_max(ice_cat_bounds(2,1)-1) = 0.0
-               !              DO jl = ice_cat_bounds(2,1), ice_cat_bounds(2,2) ! loop over ice thickness categories
-               !                 zhin(2)          = ( hi_max(jl-1) + hi_max(jl) ) / 2.0
-               !                 a_i(ji,jj,jl)    = zidto(ji,jj) * MAX( zgfactorn(2) * exp(-(zhin(2)-hginn_d)* &
-               !                                    (zhin(2)-hginn_d)/2.0) , epsi06)
-               !                 ht_i(ji,jj,jl)   = zidto(ji,jj) * zhin(2) 
-               !                 v_i(ji,jj,jl)    = ht_i(ji,jj,jl)*a_i(ji,jj,jl)
-               !              END DO
-               !              hi_max(ice_cat_bounds(2,1)-1) = zdummy
-
-               !              !rafted ice
-               !              jl = 6
-               !              a_i(ji,jj,jl)       = 0.0
-               !              ht_i(ji,jj,jl)      = 0.0
-               !              v_i(ji,jj,jl)       = 0.0
-               ! END retour a LIMA_MEC
-!!!
-
-               DO jl = 1, jpl
-
-                  !-------------
-                  ! Snow depth
-                  !-------------
-                  ht_s(ji,jj,jl)   = zidto(ji,jj) * hninn
-                  v_s(ji,jj,jl)    = ht_s(ji,jj,jl)*a_i(ji,jj,jl)
-
-                  !---------------
-                  ! Ice salinity
-                  !---------------
-                  sm_i(ji,jj,jl)   = zidto(ji,jj) * sinn  + ( 1.0 - zidto(ji,jj) ) * 0.1
-                  smv_i(ji,jj,jl)  = MIN( sm_i(ji,jj,jl) , sss_m(ji,jj) ) * v_i(ji,jj,jl)
-
-                  !----------
-                  ! Ice age
-                  !----------
-                  o_i(ji,jj,jl)    = zidto(ji,jj) * 1.0   + ( 1.0 - zidto(ji,jj) )
-                  oa_i(ji,jj,jl)   = o_i(ji,jj,jl) * a_i(ji,jj,jl)
-
-                  !------------------------------
-                  ! Sea ice surface temperature
-                  !------------------------------
-
-                  t_su(ji,jj,jl)   = zidto(ji,jj) * 270.0 + ( 1.0 - zidto(ji,jj) ) * t_bo(ji,jj)
-
-                  !------------------------------------
-                  ! Snow temperature and heat content
-                  !------------------------------------
-
-                  DO jk = 1, nlay_s
-                     t_s(ji,jj,jk,jl) = zidto(ji,jj) * 270.00 + ( 1.0 - zidto(ji,jj) ) * rtt
-                     ! Snow energy of melting
-                     e_s(ji,jj,jk,jl) = zidto(ji,jj) * rhosn * ( cpic * ( rtt - t_s(ji,jj,jk,jl) ) + lfus )
-                     ! Change dimensions
-                     e_s(ji,jj,jk,jl) = e_s(ji,jj,jk,jl) / unit_fac
-                     ! Multiply by volume, so that heat content in 10^9 Joules
-                     e_s(ji,jj,jk,jl) = e_s(ji,jj,jk,jl) * area(ji,jj) * &
-                        v_s(ji,jj,jl)  / nlay_s
-                  END DO !jk
-
-                  !-----------------------------------------------
-                  ! Ice salinities, temperature and heat content 
-                  !-----------------------------------------------
-
-                  DO jk = 1, nlay_i
-                     t_i(ji,jj,jk,jl) = zidto(ji,jj)*270.00 + ( 1.0 - zidto(ji,jj) ) * rtt 
-                     s_i(ji,jj,jk,jl) = zidto(ji,jj) * sinn + ( 1.0 - zidto(ji,jj) ) * 0.1
-                     ztmelts          = - tmut * s_i(ji,jj,jk,jl) + rtt !Melting temperature in K
-
-                     ! heat content per unit volume
-                     e_i(ji,jj,jk,jl) = zidto(ji,jj) * rhoic * &
-                        (   cpic    * ( ztmelts - t_i(ji,jj,jk,jl) ) &
-                        +   lfus    * ( 1.0 - (ztmelts-rtt) / MIN((t_i(ji,jj,jk,jl)-rtt),-zeps) ) &
-                        - rcp      * ( ztmelts - rtt ) &
-                        )
-
-                     ! Correct dimensions to avoid big values
-                     e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) / unit_fac 
-
-                     ! Mutliply by ice volume, and divide by number of layers to get heat content in 10^9 J
-                     e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) * & 
-                        area(ji,jj) * a_i(ji,jj,jl) * ht_i(ji,jj,jl) / &
-                        nlay_i
-                  END DO ! jk
-
-               END DO ! jl 
-
-            ELSE ! on fcor 
-
-               !--- Southern hemisphere
-               !----------------------------------------------------------------
-
-               !-----------------------
-               ! Ice area / thickness
-               !-----------------------
-
-               IF ( jpl .EQ. 1) THEN ! one category
-
-                  DO jl = ice_cat_bounds(1,1), ice_cat_bounds(1,2) ! loop over ice thickness categories
-                     a_i(ji,jj,jl)    = zidto(ji,jj) * agins_u
-                     ht_i(ji,jj,jl)   = zidto(ji,jj) * hgins_u
-                     v_i(ji,jj,jl)    = ht_i(ji,jj,jl)*a_i(ji,jj,jl)
-                  END DO
-
-               ELSE ! several categories
-
-                  !level ice
-                  DO jl = ice_cat_bounds(1,1), ice_cat_bounds(1,2) !over thickness categories
-
-                     zhis(1)       = ( hi_max(jl-1) + hi_max(jl) ) / 2.0
-                     a_i(ji,jj,jl) = zidto(ji,jj) * MAX( zgfactors(1) * exp(-(zhis(1)-hgins_u) * & 
-                        (zhis(1)-hgins_u)/2.0) , epsi06 )
-                     ! new line square distribution volume conserving
-                     a_i(ji,jj,jl)    = zidto(ji,jj) * ( zas * zhis(1) * zhis(1) + zbs * zhis(1) )
-                     ht_i(ji,jj,jl)   = zidto(ji,jj) * zhis(1) 
-                     v_i(ji,jj,jl)    = ht_i(ji,jj,jl)*a_i(ji,jj,jl)
-
-                  END DO ! jl
-
-               ENDIF
-
-!!!
-               ! retour a LIMA_MEC
-               !              !ridged ice
-               !              zdummy  = hi_max(ice_cat_bounds(2,1)-1)
-               !              hi_max(ice_cat_bounds(2,1)-1) = 0.0
-               !              DO jl = ice_cat_bounds(2,1), ice_cat_bounds(2,2) !over thickness categories
-               !                 zhis(2)       = ( hi_max(jl-1) + hi_max(jl) ) / 2.0
-               !                 a_i(ji,jj,jl) = zidto(ji,jj)*MAX( zgfactors(2)   &
-               !                    &          * exp(-(zhis(2)-hgins_d)*(zhis(2)-hgins_d)/2.0), epsi06 )
-               !                 ht_i(ji,jj,jl)   = zidto(ji,jj) * zhis(2) 
-               !                 v_i(ji,jj,jl)    = ht_i(ji,jj,jl)*a_i(ji,jj,jl)
-               !              END DO
-               !              hi_max(ice_cat_bounds(2,1)-1) = zdummy
-
-               !              !rafted ice
-               !              jl = 6
-               !              a_i(ji,jj,jl)       = 0.0
-               !              ht_i(ji,jj,jl)      = 0.0
-               !              v_i(ji,jj,jl)       = 0.0
-               ! END retour a LIMA_MEC
-!!!
-
-               DO jl = 1, jpl !over thickness categories
-
-                  !---------------
-                  ! Snow depth
-                  !---------------
-
-                  ht_s(ji,jj,jl)   = zidto(ji,jj) * hnins
-                  v_s(ji,jj,jl)    = ht_s(ji,jj,jl)*a_i(ji,jj,jl)
-
-                  !---------------
-                  ! Ice salinity
-                  !---------------
-
-                  sm_i(ji,jj,jl)   = zidto(ji,jj) * sins  + ( 1.0 - zidto(ji,jj) ) * 0.1
-                  smv_i(ji,jj,jl)  = MIN( sm_i(ji,jj,jl) , sss_m(ji,jj) ) * v_i(ji,jj,jl)
-
-                  !----------
-                  ! Ice age
-                  !----------
-
-                  o_i(ji,jj,jl)    = zidto(ji,jj) * 1.0   + ( 1.0 - zidto(ji,jj) )
-                  oa_i(ji,jj,jl)   = o_i(ji,jj,jl) * a_i(ji,jj,jl)
-
-                  !------------------------------
-                  ! Sea ice surface temperature
-                  !------------------------------
-
-                  t_su(ji,jj,jl)   = zidto(ji,jj) * 270.0 + ( 1.0 - zidto(ji,jj) ) * t_bo(ji,jj)
-
-                  !----------------------------------
-                  ! Snow temperature / heat content
-                  !----------------------------------
-
-                  DO jk = 1, nlay_s
-                     t_s(ji,jj,jk,jl) = zidto(ji,jj) * 270.00 + ( 1.0 - zidto(ji,jj) ) * rtt
-                     ! Snow energy of melting
-                     e_s(ji,jj,jk,jl) = zidto(ji,jj) * rhosn * ( cpic * ( rtt - t_s(ji,jj,jk,jl) ) + lfus )
-                     ! Change dimensions
-                     e_s(ji,jj,jk,jl) = e_s(ji,jj,jk,jl) / unit_fac
-                     ! Multiply by volume, so that heat content in 10^9 Joules
-                     e_s(ji,jj,jk,jl) = e_s(ji,jj,jk,jl) * area(ji,jj) * &
-                        v_s(ji,jj,jl)  / nlay_s
-                  END DO
-
-                  !---------------------------------------------
-                  ! Ice temperature, salinity and heat content
-                  !---------------------------------------------
-
-                  DO jk = 1, nlay_i
-                     t_i(ji,jj,jk,jl) = zidto(ji,jj)*270.00 + ( 1.0 - zidto(ji,jj) ) * rtt 
-                     s_i(ji,jj,jk,jl) = zidto(ji,jj) * sins + ( 1.0 - zidto(ji,jj) ) * 0.1
-                     ztmelts          = - tmut * s_i(ji,jj,jk,jl) + rtt !Melting temperature in K
-
-                     ! heat content per unit volume
-                     e_i(ji,jj,jk,jl) = zidto(ji,jj) * rhoic * &
-                        (   cpic    * ( ztmelts - t_i(ji,jj,jk,jl) ) &
-                        +   lfus  * ( 1.0 - (ztmelts-rtt) / MIN((t_i(ji,jj,jk,jl)-rtt),-zeps) ) &
-                        - rcp      * ( ztmelts - rtt ) &
-                        )
-
-                     ! Correct dimensions to avoid big values
-                     e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) / unit_fac 
-
-                     ! Mutliply by ice volume, and divide by number of layers to get heat content in 10^9 J
-                     e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) * & 
-                        area(ji,jj) * a_i(ji,jj,jl) * ht_i(ji,jj,jl) / &
-                        nlay_i
-                  END DO !jk
-
-               END DO ! jl 
-
-            ENDIF ! on fcor
-
+               a_i(ji,jj,jl)    = zidto(ji,jj) * zai(jl)
+               ht_i(ji,jj,jl)   = zidto(ji,jj) * zhti(jl)
+               v_i(ji,jj,jl)    = ht_i(ji,jj,jl)*a_i(ji,jj,jl)
+               
+               !-------------
+               ! Snow depth
+               !-------------
+               ht_s(ji,jj,jl)   = zidto(ji,jj) * zhts(jl)
+               v_s(ji,jj,jl)    = ht_s(ji,jj,jl)*a_i(ji,jj,jl)
+               
+               !---------------
+               ! Ice salinity
+               !---------------
+               sm_i(ji,jj,jl)   = zidto(ji,jj) * sinn  + ( 1.0 - zidto(ji,jj) ) * 0.1
+               smv_i(ji,jj,jl)  = MIN( sm_i(ji,jj,jl) , sss_m(ji,jj) ) * v_i(ji,jj,jl)
+               
+               !----------
+               ! Ice age
+               !----------
+               o_i(ji,jj,jl)    = zidto(ji,jj) * 1.0   + ( 1.0 - zidto(ji,jj) )
+               oa_i(ji,jj,jl)   = o_i(ji,jj,jl) * a_i(ji,jj,jl)
+               
+               !------------------------------
+               ! Sea ice surface temperature
+               !------------------------------
+               t_su(ji,jj,jl)   = zidto(ji,jj) * 270.0 + ( 1.0 - zidto(ji,jj) ) * t_bo(ji,jj)
+               
+               !------------------------------------
+               ! Snow temperature and heat content
+               !------------------------------------
+               DO jk = 1, nlay_s
+                  t_s(ji,jj,jk,jl) = zidto(ji,jj) * 270.00 + ( 1.0 - zidto(ji,jj) ) * rtt
+                  ! Snow energy of melting
+                  e_s(ji,jj,jk,jl) = zidto(ji,jj) * rhosn * ( cpic * ( rtt - t_s(ji,jj,jk,jl) ) + lfus )
+                  ! Change dimensions
+                  e_s(ji,jj,jk,jl) = e_s(ji,jj,jk,jl) / unit_fac
+                  ! Multiply by volume, so that heat content in 10^9 Joules
+                  e_s(ji,jj,jk,jl) = e_s(ji,jj,jk,jl) * area(ji,jj) * &
+                       v_s(ji,jj,jl)  / REAL( nlay_s )
+               END DO !jk
+               
+               !-----------------------------------------------
+               ! Ice salinities, temperature and heat content 
+               !-----------------------------------------------
+               DO jk = 1, nlay_i
+                  t_i(ji,jj,jk,jl) = zidto(ji,jj)*270.00 + ( 1.0 - zidto(ji,jj) ) * rtt 
+                  s_i(ji,jj,jk,jl) = zidto(ji,jj) * sinn + ( 1.0 - zidto(ji,jj) ) * 0.1
+                  ztmelts          = - tmut * s_i(ji,jj,jk,jl) + rtt !Melting temperature in K
+                  
+                  ! heat content per unit volume
+                  e_i(ji,jj,jk,jl) = zidto(ji,jj) * rhoic * &
+                       (   cpic    * ( ztmelts - t_i(ji,jj,jk,jl) ) &
+                       +   lfus    * ( 1.0 - (ztmelts-rtt) / MIN((t_i(ji,jj,jk,jl)-rtt),-zeps) ) &
+                       - rcp      * ( ztmelts - rtt ) &
+                       )
+                  
+                  ! Correct dimensions to avoid big values
+                  e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) / unit_fac 
+                  
+                  ! Mutliply by ice volume, and divide by number of layers to get heat content in 10^9 J
+                  e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) * & 
+                       area(ji,jj) * a_i(ji,jj,jl) * ht_i(ji,jj,jl) / &
+                       REAL( nlay_i )
+               END DO ! jk
+               
+            END DO ! jl 
+            
          END DO
       END DO
-
-      !--------------------------------------------------------------------
-      ! 3) Global ice variables for output diagnostics                    | 
+ 
+      IF(lwp) THEN                        ! control print
+         WRITE(numout,*) '~~~~~~~~~~~~~~~'
+         WRITE(numout,*) '   max ice  thickness   = ', (MAXVAL(ht_i(:,:,jl)),jl=1,jpl)
+         WRITE(numout,*) '   max snow thickness   = ', (MAXVAL(ht_s(:,:,jl)),jl=1,jpl)
+         WRITE(numout,*) '   max ice  area        = ', (MAXVAL(a_i(:,:,jl)),jl=1,jpl)
+         WRITE(numout,*) '   max ice  salinity    = ', (MAXVAL(sm_i(:,:,jl)),jl=1,jpl)
+         WRITE(numout,*) '   min ice  salinity    = ', (MINVAL(sm_i(:,:,jl)),jl=1,jpl)
+         WRITE(numout,*) '   max ice  surf temper = ', (MAXVAL(t_su(:,:,jl)-rtt),jl=1,jpl)
+         WRITE(numout,*) '   min ice  surf temper = ', (MINVAL(t_su(:,:,jl)-rtt),jl=1,jpl)
+      ENDIF
+
+      !--------------------------------------------------------------------
+      ! 5) Global ice variables for output diagnostics                    | 
       !--------------------------------------------------------------------
 
@@ -458,5 +419,5 @@
 
       !--------------------------------------------------------------------
-      ! 4) Moments for advection
+      ! 6) Moments for advection
       !--------------------------------------------------------------------
 
@@ -485,6 +446,8 @@
       sxysal (:,:,:)  = 0.e0
 
-      !--------------------------------------------------------------------
-      ! 5) Lateral boundary conditions                                    | 
+      sxopw(:,:) = 0.e0 ; syopw(:,:) = 0.e0; sxxopw(:,:) = 0.e0; syyopw(:,:) = 0.e0; sxyopw(:,:) = 0.e0
+
+      !--------------------------------------------------------------------
+      ! 7) Lateral boundary conditions                                    | 
       !--------------------------------------------------------------------
 
@@ -518,5 +481,4 @@
       CALL lbc_lnk( fsbbq  , 'T', 1. )
       !
-      CALL wrk_dealloc( jpm, zgfactorn, zgfactors, zhin, zhis )
       CALL wrk_dealloc( jpi, jpj, zidto )
       !
